;; Batch Conversion of WAV files to Zx AY
;; This is meant for 128k Speccy using the
;; typical SAVE! command... 
;; 
;; By Karl McNel August 10th/2007...

#include <File.au3>

$WaveDir=FileSelectFolder ( "Locate Folder with WAV files to Process", "", 4 , @ScriptDir&"\Shortcuts2")

; Count number of Wav files in Dir
$Count=0
$search = FileFindFirstFile($WaveDir&"\"&"*.wav*") 

If $search = -1 Then
    MsgBox(0, "Error", "No WAV samples in the Directory!")
    Exit
EndIf

While 1
    $file = FileFindNextFile($search) 
    If @error Then ExitLoop
    $Count=$Count+1    
WEnd
$TotalSamples=$Count
; Close the search handle
FileClose($search)



; DEFAULT ASSEMBLY ADDRESS SETTINGS:::

$D_ORG= InputBox("Set Assembly Origin Start Address", "To relocate the original player code, type in a new Origin here, else click OK","32768","")

$D_CLEAR=$D_ORG-1

$D_SAMADDR=InputBox("Set Sample Start Address", "Hit OK to append samples to the end of the player code, else set new position.",$D_ORG+232,"")

$D_ADDRTAB1=InputBox("Set Sample Address Table", "Hit OK unless you've radically rewritten the original code to dump sample address elsewhere.",$D_ORG+1,"")

$D_ADDRTAB2=InputBox("Set Sample Length Table", "Again, Hit OK unless you've radically rewritten the code to dump sample length data elsewhere.",$D_ORG+4,"")

_FileWriteToLine("VariableOrigin.asm",3, "    org "&$D_ORG, 1)

_FileWriteToLine("Header.bas",1, "10 CLEAR "&$D_CLEAR,1)
_FileWriteToLine("Header.bas",2, "20 LET ORG="&$D_ORG&": LET TSAMS="&$TotalSamples&": LET LENADDR="&$D_ADDRTAB2&": LET SAMADDR="&$D_ADDRTAB1,1)



Sleep(1000)
RUNWAIT("Pasmo.exe -v --bin VariableOrigin.asm Player.bin")
SLEEP(1000)
RUNWAIT("Bas2TAP -a1 -sMAIN Header.bas Output.Tap")
$Tmp="file2tap Player.bin Output.Tap -sPlayer -a"&$D_ORG&" -e"
RUNWAIT($Tmp)

;NEED to insert Sample Start Settings into the TAP now...
FileCopy ("Empty.bin", "2Bytes.bin",1)
$ByteNumber=$D_SAMADDR
$ByteTwo=INT($ByteNumber/256)
$ByteOne=$ByteNumber-($ByteTwo*256)

FileWrite("2Bytes.bin", Chr($ByteOne)&Chr($ByteTwo))
Sleep(1000)
$Tmp="file2tap 2Bytes.bin Output.Tap -sSETSTART -a"&$D_ADDRTAB1&" -e"
RUNWAIT($Tmp)

; Process all the WAV's in said $WaveDir to TAP
$Count=0
$search = FileFindFirstFile($WaveDir&"\"&"*.wav*")  
; Check if the search was successful
If $search = -1 Then
    MsgBox(0, "Where have your WAV files gone?!?!!?")
    Exit
EndIf

While 1
    $file = FileFindNextFile($search) 
    If @error Then ExitLoop
    $Count=$Count+1

FileCopy ($WaveDir&"\"&$file, "./input.wav",1)

RUNWAIT("sox input.wav -r 11025 -b -u -c1 Output.raw")
RUNWAIT("sam2ay.exe")

;NEED to insert Sample lengths into the TAP now...
FileCopy ("Empty.bin", "2Bytes.bin",1)
$ByteNumber=FileGetSize("Output.Ay")
$ByteTwo=INT($ByteNumber/256)
$ByteOne=$ByteNumber-($ByteTwo*256)
FileWrite("2Bytes.bin", chr($ByteOne)&Chr($ByteTwo))
Sleep(500)
$Tmp="file2tap 2Bytes.bin Output.Tap -s"&"SLen_"&$Count&" -a"&$D_ADDRTAB2&" -e"
RUNWAIT($Tmp)

$Tmp="file2tap Output.ay Output.Tap -sSAM_"&$Count&" -a"&$D_SAMADDR&" -e"
RUNWAIT($Tmp)
WEnd

; Close the search handle  
FileClose($search)
FileCopy ("Output.Tap",$WaveDir&"\Output.Tap",1)
$TotalSamples=$Count
MsgBox(4096, "All Done!", $TotalSamples&" sounds processed")
